---
uid: index.md
title: Introduction
---

<p align="center">
<br/>
  <img src="https://raw.githubusercontent.com/Mono-Game/MonoGame.Logo/master/FullColorOnLight/HorizontalLogo_128px.png"/>
<br/>
<br/>
</p>

Welcome to the MonoGame documentation hub!

MonoGame is a simple and powerful .NET library for creating games for desktop PCs, video game consoles, and mobile devices.

Based on [Microsoft's XNA Framework](https://msdn.microsoft.com/en-us/library/bb200104.aspx), it provides the following features:

- Game framework
- 2D and 3D rendering
- Sound effect and music playback
- Keyboard, mouse, touch, and controller inputs
- Content building and optimization
- Math library optimized for games

This documentation helps you get started, providing overviews of key features and tools and a complete API reference.

Please use the links at the top and left to navigate the documentation sections.

## We Need Your Help!

Great open source projects require high-quality documentation.  This is a call for volunteers to continue to help us make the MonoGame documentation truly great.  If you can create tutorials, feature guides, code snippets, reference docs, or video walkthroughs, or make any improvement to our current documentation, we could use your help!

Check out the [README on GitHub](https://github.com/MonoGame/MonoGame/blob/develop/README.md) or [talk with us on the community site](http://community.monogame.net/t/lets-improve-the-monogame-documentation/916) to learn how to help!
